from typing import Dict, List
import json
from app.labels_system.getter import get_selected_elements, get_discriminating_labels, get_high_discriminating_labels, get_user_selection
from app.labels_system import bp


#URLs call to update labels and elements along researchs

@bp.route('/search/<int:number_of_mandatory_labels>', defaults={'optional1':'', 'optional2':''})
@bp.route('/search/<int:number_of_mandatory_labels>/<string:optional1>', defaults={'optional2':''})
@bp.route('/search/<int:number_of_mandatory_labels>/<string:optional1>/<string:optional2>')
def search(number_of_mandatory_labels: int, optional1: str, optional2: str) -> List[List[Dict[int, str]]] :
    '''
    Return updated lists of selected elements and high discriminating labels useful to continu research
    :param number_of_mandatory_labels: int
    :param optional1: str
    :param optional2: str
    :return: List[List[Dict[int, str]]]
    '''
    id_mandatory_labels, id_forbiden_labels = get_user_selection(number_of_mandatory_labels, optional1, optional2)
    selected_elements = get_selected_elements(id_mandatory_labels, id_forbiden_labels, number_of_mandatory_labels)
    high_discriminating_labels = get_high_discriminating_labels(get_discriminating_labels(selected_elements))
    result = [selected_elements, high_discriminating_labels]
    return json.dumps(result)

